/*

    Copyright (C) 2003 Bjorn Martins Paz (bmp@narpax.com.br)
    Copyright (C) 2003 Davi Einstein Melges Arnaut (dema@narpax.com.br)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "TCheckBoxWindow.h"
#include "TString.h"

/*----------------------------------------------------------------------------------------------*/
/* Constructor */
TAdvCheckBoxes::TAdvCheckBoxes(unsigned int *pnValue, const TRect &bounds, TSItem *aString)
               : TCheckBoxes(bounds, aString) {
   m_pnValue = pnValue;
}

/*----------------------------------------------------------------------------------------------*/
/* Constructor */
TCheckBoxWindow::TCheckBoxWindow(unsigned int *pnValue, const char *sTitle, TStringCollection* Rcpts)
                : TDialog( TRect(0,0,0,0), sTitle ), TWindowInit(&TCheckBoxWindow::initFrame) {
   TString sLabel;
   TSItem *first = NULL;
   TSItem *temp = NULL;
   TSItem *temp2 = NULL;
   int i,j;

   j = Rcpts->getCount();

   m_pnValue = pnValue;

   TRect& rWin = calcRect(Rcpts);
   TRect& rBox = *new TRect(1, 1, rWin.b.x-1, j+1);

   this->changeBounds(rWin);

   for( i=0; i<j; i++ ) {
      sLabel.clean();
      sLabel += "~";
      sLabel += itoa(i);
      sLabel += "~ ";
      sLabel += (char *)Rcpts->at(i);
      temp2 = new TSItem( sLabel.getData(), 0 );
      if( temp == NULL ) {
         temp = temp2;
         first = temp;
      }
      else {
         temp->next = temp2;
         temp = temp2;
      }
   }
   sLabel.clean();

   TAdvCheckBoxes *m_pBoxes = new TAdvCheckBoxes( pnValue, rBox, first );
   this->insert( m_pBoxes );
   this->insert( new TButton( TRect((rWin.b.x>>1)-5, rWin.b.y-3, (rWin.b.x>>1)+5, rWin.b.y-1), "~O~K", cmOK, bfDefault) );
}

/*----------------------------------------------------------------------------------------------*/
/* Calc Rectangle */
TRect& TCheckBoxWindow::calcRect( TStringCollection *Rcpts ) {
   TRect& r = *new TRect(0,0,0,0);
   TRect  b = TProgram::deskTop->getExtent();
   ccIndex i, j;
   int a;

   j = Rcpts->getCount();

   for( i=0; i<j; i++ ) {
      a = strlen( (char *) Rcpts->at(i) );

      if( a > r.b.x ) {
         if( a > b.b.x )
            a = b.b.x;
         r.b.x = a;
      }

      r.b.y++;
   }

   r.b.x += 10;
   r.b.y += 5;
   if( r.b.y < 6 )
      r.b.y = 6;

   return r;
}

/*----------------------------------------------------------------------------------------------*/
/* Integer to ASCII */
char * TCheckBoxWindow::itoa( int value ) {
   const int max = 3*sizeof(int)+1 ;
   static char temp[max+1];
   bool negative = false;
   int i, p;

   temp[max] = '\0';
   p = max-1;

   if( value == 0 ) {
      temp[p] = '0';
      return &temp[p];
   }
    
   if( value < 0 )
      negative = true;
   
   while(value > 0) {
      i = value % 10;
      temp[p] = i + 0x30;
      value /= 10;
      p--;
   }

   if( negative )
      temp[p] = '-';
   else
      p++;

   return &temp[p];
}

