/*

    Copyright (C) 2003 Bjorn Martins Paz (bmp@narpax.com.br)
    Copyright (C) 2003 Davi Einstein Melges Arnaut (dema@narpax.com.br)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "TMsgBox.h"

/*----------------------------------------------------------------------------------------------*/
/* Constructor */
TMsgBox::TMsgBox(const char *title, const char *sText)
       : TDialog(TRect(0,0,0,0), title), TWindowInit(&TMsgBox::initFrame) {

   TRect rWin = this->calcRect(sText);
   TRect rTxt = TRect(2, 1, rWin.b.x-1, rWin.b.y-4);
   TRect rBut = TRect(rWin.b.x/2-5, rWin.b.y-3, rWin.b.x/2+5, rWin.b.y-1);

   this->changeBounds(rWin);
   this->options |= ofCentered;

   this->insert( new TStaticText( rTxt, sText ) );
   this->insert( new TButton( rBut, "~O~K", cmOK, bfDefault ) );
}

/*----------------------------------------------------------------------------------------------*/
/* Calc Rectangle */
TRect& TMsgBox::calcRect(const char *txt) {
   TRect& r = *new TRect(0,0,0,0);
   int i = 0, x = 0;

   while( txt[i] != '\0' ) {
      if( txt[i] == '\n' ) {
         x = 0;
         r.b.y++;
         i++;
         continue;
      }

      if(x > r.b.x)
         r.b.x = x;

      x++;
      i++;
   }

   if( r.b.x < 16 )
      r.b.x = 16;
   else
      r.b.x += 5;

   if( r.b.y < 6 )
      r.b.y = 6;
   else
      r.b.y += 4;

   return r;
}
